#!/bin/sh
# $Id: t-list-0.sh,v 1.7 2005/10/21 18:02:19 ca Exp $
# Copyright (c) 2005 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#
# ----------------------------------------
# test alias expansion for long lists
# uses smtpcnf.sh
# ----------------------------------------
#
test -s stop && exit 1
#

SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../chkmts
fi
. ${SD}/common.sh

OUT="t-list-0.out"

if test X"`uname`" != "XOSF1"
then
while getopts s:V FLAG
do
  case "${FLAG}" in
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

# cd to working directory for alias file!
cd ../qmgr || exit 1

# create aliases
${CAT} > ${ALI} <<EOF
abuse:	local:
postmaster:	local:
user:	local:
sender*: local:
longsome: <user0@some.long.domain> <user1@some.long.domain> <user2@some.long.domain> <user3@some.long.domain> <user4@some.long.domain> <user5@some.long.domain> <user6@some.long.domain> <user7@some.long.domain> <user8@some.long.domain> <user9@some.long.domain> <user10@some.long.domain> <user11@some.long.domain> <user12@some.long.domain> <user13@some.long.domain> <user14@some.long.domain> <user15@some.long.domain> <user16@some.long.domain> <user17@some.long.domain> <user18@some.long.domain> <user19@some.long.domain> <user20@some.long.domain> <user21@some.long.domain> <user22@some.long.domain> <user23@some.long.domain> <user24@some.long.domain> <user25@some.long.domain> <user26@some.long.domain> <user27@some.long.domain> <user28@some.long.domain> <user29@some.long.domain> <user30@some.long.domain> <user31@some.long.domain> <user32@some.long.domain> <user33@some.long.domain> <user34@some.long.domain> <user35@some.long.domain> <user36@some.long.domain> <user37@some.long.domain> <user38@some.long.domain> <user39@some.long.domain> <user40@some.long.domain> <user41@some.long.domain> <user42@some.long.domain> <user43@some.long.domain> <user44@some.long.domain> <user45@some.long.domain> <user46@some.long.domain> <user47@some.long.domain> <user48@some.long.domain> <user49@some.long.domain> <user50@some.long.domain> <user51@some.long.domain> <user52@some.long.domain> <user53@some.long.domain> <user54@some.long.domain> <user55@some.long.domain> <user56@some.long.domain> <user57@some.long.domain> <user58@some.long.domain> <user59@some.long.domain> <user60@some.long.domain> <user61@some.long.domain> <user62@some.long.domain> <user63@some.long.domain> <user64@some.long.domain> <user65@some.long.domain> <user66@some.long.domain> <user67@some.long.domain> <user68@some.long.domain> <user69@some.long.domain> <user70@some.long.domain> <user71@some.long.domain> <user72@some.long.domain> <user73@some.long.domain> <user74@some.long.domain> <user75@some.long.domain> <user76@some.long.domain> <user77@some.long.domain> <user78@some.long.domain> <user79@some.long.domain> <user80@some.long.domain> <user81@some.long.domain> <user82@some.long.domain> <user83@some.long.domain> <user84@some.long.domain> <user85@some.long.domain> <user86@some.long.domain> <user87@some.long.domain> <user88@some.long.domain> <user89@some.long.domain> <user90@some.long.domain> <user91@some.long.domain> <user92@some.long.domain> <user93@some.long.domain> <user94@some.long.domain> <user95@some.long.domain> <user96@some.long.domain> <user97@some.long.domain> <user98@some.long.domain> <user99@some.long.domain>
long: <user0@long.domain> <user1@long.domain> <user2@long.domain> <user3@long.domain> <user4@long.domain> <user5@long.domain> <user6@long.domain> <user7@long.domain> <user8@long.domain> <user9@long.domain> <user10@long.domain> <user11@long.domain> <user12@long.domain> <user13@long.domain> <user14@long.domain> <user15@long.domain> <user16@long.domain> <user17@long.domain> <user18@long.domain> <user19@long.domain> <user20@long.domain> <user21@long.domain> <user22@long.domain> <user23@long.domain> <user24@long.domain> <user25@long.domain> <user26@long.domain> <user27@long.domain> <user28@long.domain> <user29@long.domain> <user30@long.domain> <user31@long.domain> <user32@long.domain> <user33@long.domain> <user34@long.domain> <user35@long.domain> <user36@long.domain> <user37@long.domain> <user38@long.domain> <user39@long.domain> <user40@long.domain> <user41@long.domain> <user42@long.domain> <user43@long.domain> <user44@long.domain> <user45@long.domain> <user46@long.domain> <user47@long.domain> <user48@long.domain> <user49@long.domain> <user50@long.domain> <user51@long.domain> <user52@long.domain> <user53@long.domain> <user54@long.domain> <user55@long.domain> <user56@long.domain> <user57@long.domain> <user58@long.domain> <user59@long.domain> <user60@long.domain> <user61@long.domain> <user62@long.domain> <user63@long.domain> <user64@long.domain> <user65@long.domain> <user66@long.domain> <user67@long.domain> <user68@long.domain> <user69@long.domain> <user70@long.domain> <user71@long.domain> <user72@long.domain> <user73@long.domain> <user74@long.domain> <user75@long.domain> <user76@long.domain> <user77@long.domain> <user78@long.domain> <user79@long.domain> <user80@long.domain> <user81@long.domain> <user82@long.domain> <user83@long.domain> <user84@long.domain> <user85@long.domain> <user86@long.domain> <user87@long.domain> <user88@long.domain> <user89@long.domain> <user90@long.domain> <user91@long.domain> <user92@long.domain> <user93@long.domain> <user94@long.domain> <user95@long.domain> <user96@long.domain> <user97@long.domain> <user98@long.domain> <user99@long.domain>
longsub: <user0@sub0.long.domain> <user1@sub1.long.domain> <user2@sub2.long.domain> <user3@sub3.long.domain> <user4@sub4.long.domain> <user5@sub5.long.domain> <user6@sub6.long.domain> <user7@sub7.long.domain> <user8@sub8.long.domain> <user9@sub9.long.domain> <user10@sub10.long.domain> <user11@sub11.long.domain> <user12@sub12.long.domain> <user13@sub13.long.domain> <user14@sub14.long.domain> <user15@sub15.long.domain> <user16@sub16.long.domain> <user17@sub17.long.domain> <user18@sub18.long.domain> <user19@sub19.long.domain> <user20@sub20.long.domain> <user21@sub21.long.domain> <user22@sub22.long.domain> <user23@sub23.long.domain> <user24@sub24.long.domain> <user25@sub25.long.domain> <user26@sub26.long.domain> <user27@sub27.long.domain> <user28@sub28.long.domain> <user29@sub29.long.domain> <user30@sub30.long.domain> <user31@sub31.long.domain> <user32@sub32.long.domain> <user33@sub33.long.domain> <user34@sub34.long.domain> <user35@sub35.long.domain> <user36@sub36.long.domain> <user37@sub37.long.domain> <user38@sub38.long.domain> <user39@sub39.long.domain> <user40@sub40.long.domain> <user41@sub41.long.domain> <user42@sub42.long.domain> <user43@sub43.long.domain> <user44@sub44.long.domain> <user45@sub45.long.domain> <user46@sub46.long.domain> <user47@sub47.long.domain> <user48@sub48.long.domain> <user49@sub49.long.domain> <user50@sub50.long.domain> <user51@sub51.long.domain> <user52@sub52.long.domain> <user53@sub53.long.domain> <user54@sub54.long.domain> <user55@sub55.long.domain> <user56@sub56.long.domain> <user57@sub57.long.domain> <user58@sub58.long.domain> <user59@sub59.long.domain> <user60@sub60.long.domain> <user61@sub61.long.domain> <user62@sub62.long.domain> <user63@sub63.long.domain> <user64@sub64.long.domain> <user65@sub65.long.domain> <user66@sub66.long.domain> <user67@sub67.long.domain> <user68@sub68.long.domain> <user69@sub69.long.domain> <user70@sub70.long.domain> <user71@sub71.long.domain> <user72@sub72.long.domain> <user73@sub73.long.domain> <user74@sub74.long.domain> <user75@sub75.long.domain> <user76@sub76.long.domain> <user77@sub77.long.domain> <user78@sub78.long.domain> <user79@sub79.long.domain> <user80@sub80.long.domain> <user81@sub81.long.domain> <user82@sub82.long.domain> <user83@sub83.long.domain> <user84@sub84.long.domain> <user85@sub85.long.domain> <user86@sub86.long.domain> <user87@sub87.long.domain> <user88@sub88.long.domain> <user89@sub89.long.domain> <user90@sub90.long.domain> <user91@sub91.long.domain> <user92@sub92.long.domain> <user93@sub93.long.domain> <user94@sub94.long.domain> <user95@sub95.long.domain> <user96@sub96.long.domain> <user97@sub97.long.domain> <user98@sub98.long.domain> <user99@sub99.long.domain>
long+some: <long@local.dom> <longsome@local.dom>
long+sub: <long@local.dom> <longsub@local.dom>
long+sub+some: <long@local.dom> <longsub@local.dom> <longsome@local.dom>
longsub-a00: <user0@sub-a00-0.long.domain> <user1@sub-a00-1.long.domain> <user2@sub-a00-2.long.domain> <user3@sub-a00-3.long.domain> <user4@sub-a00-4.long.domain> <user5@sub-a00-5.long.domain> <user6@sub-a00-6.long.domain> <user7@sub-a00-7.long.domain> <user8@sub-a00-8.long.domain> <user9@sub-a00-9.long.domain> <user10@sub-a00-10.long.domain> <user11@sub-a00-11.long.domain> <user12@sub-a00-12.long.domain> <user13@sub-a00-13.long.domain> <user14@sub-a00-14.long.domain> <user15@sub-a00-15.long.domain> <user16@sub-a00-16.long.domain> <user17@sub-a00-17.long.domain> <user18@sub-a00-18.long.domain> <user19@sub-a00-19.long.domain> <user20@sub-a00-20.long.domain> <user21@sub-a00-21.long.domain> <user22@sub-a00-22.long.domain> <user23@sub-a00-23.long.domain> <user24@sub-a00-24.long.domain> <user25@sub-a00-25.long.domain> <user26@sub-a00-26.long.domain> <user27@sub-a00-27.long.domain> <user28@sub-a00-28.long.domain> <user29@sub-a00-29.long.domain> <user30@sub-a00-30.long.domain> <user31@sub-a00-31.long.domain> <user32@sub-a00-32.long.domain> <user33@sub-a00-33.long.domain> <user34@sub-a00-34.long.domain> <user35@sub-a00-35.long.domain> <user36@sub-a00-36.long.domain> <user37@sub-a00-37.long.domain> <user38@sub-a00-38.long.domain> <user39@sub-a00-39.long.domain> <user40@sub-a00-40.long.domain> <user41@sub-a00-41.long.domain> <user42@sub-a00-42.long.domain> <user43@sub-a00-43.long.domain> <user44@sub-a00-44.long.domain> <user45@sub-a00-45.long.domain> <user46@sub-a00-46.long.domain> <user47@sub-a00-47.long.domain> <user48@sub-a00-48.long.domain> <user49@sub-a00-49.long.domain> <user50@sub-a00-50.long.domain> <user51@sub-a00-51.long.domain> <user52@sub-a00-52.long.domain> <user53@sub-a00-53.long.domain> <user54@sub-a00-54.long.domain> <user55@sub-a00-55.long.domain> <user56@sub-a00-56.long.domain> <user57@sub-a00-57.long.domain> <user58@sub-a00-58.long.domain> <user59@sub-a00-59.long.domain> <user60@sub-a00-60.long.domain> <user61@sub-a00-61.long.domain> <user62@sub-a00-62.long.domain> <user63@sub-a00-63.long.domain> <user64@sub-a00-64.long.domain> <user65@sub-a00-65.long.domain> <user66@sub-a00-66.long.domain> <user67@sub-a00-67.long.domain> <user68@sub-a00-68.long.domain> <user69@sub-a00-69.long.domain> <user70@sub-a00-70.long.domain> <user71@sub-a00-71.long.domain> <user72@sub-a00-72.long.domain> <user73@sub-a00-73.long.domain> <user74@sub-a00-74.long.domain> <user75@sub-a00-75.long.domain> <user76@sub-a00-76.long.domain> <user77@sub-a00-77.long.domain> <user78@sub-a00-78.long.domain> <user79@sub-a00-79.long.domain> <user80@sub-a00-80.long.domain> <user81@sub-a00-81.long.domain> <user82@sub-a00-82.long.domain> <user83@sub-a00-83.long.domain> <user84@sub-a00-84.long.domain> <user85@sub-a00-85.long.domain> <user86@sub-a00-86.long.domain> <user87@sub-a00-87.long.domain> <user88@sub-a00-88.long.domain> <user89@sub-a00-89.long.domain> <user90@sub-a00-90.long.domain> <user91@sub-a00-91.long.domain> <user92@sub-a00-92.long.domain> <user93@sub-a00-93.long.domain> <user94@sub-a00-94.long.domain> <user95@sub-a00-95.long.domain> <user96@sub-a00-96.long.domain> <user97@sub-a00-97.long.domain> <user98@sub-a00-98.long.domain> <user99@sub-a00-99.long.domain>
longsub-a01: <user0@sub-a01-0.long.domain> <user1@sub-a01-1.long.domain> <user2@sub-a01-2.long.domain> <user3@sub-a01-3.long.domain> <user4@sub-a01-4.long.domain> <user5@sub-a01-5.long.domain> <user6@sub-a01-6.long.domain> <user7@sub-a01-7.long.domain> <user8@sub-a01-8.long.domain> <user9@sub-a01-9.long.domain> <user10@sub-a01-10.long.domain> <user11@sub-a01-11.long.domain> <user12@sub-a01-12.long.domain> <user13@sub-a01-13.long.domain> <user14@sub-a01-14.long.domain> <user15@sub-a01-15.long.domain> <user16@sub-a01-16.long.domain> <user17@sub-a01-17.long.domain> <user18@sub-a01-18.long.domain> <user19@sub-a01-19.long.domain> <user20@sub-a01-20.long.domain> <user21@sub-a01-21.long.domain> <user22@sub-a01-22.long.domain> <user23@sub-a01-23.long.domain> <user24@sub-a01-24.long.domain> <user25@sub-a01-25.long.domain> <user26@sub-a01-26.long.domain> <user27@sub-a01-27.long.domain> <user28@sub-a01-28.long.domain> <user29@sub-a01-29.long.domain> <user30@sub-a01-30.long.domain> <user31@sub-a01-31.long.domain> <user32@sub-a01-32.long.domain> <user33@sub-a01-33.long.domain> <user34@sub-a01-34.long.domain> <user35@sub-a01-35.long.domain> <user36@sub-a01-36.long.domain> <user37@sub-a01-37.long.domain> <user38@sub-a01-38.long.domain> <user39@sub-a01-39.long.domain> <user40@sub-a01-40.long.domain> <user41@sub-a01-41.long.domain> <user42@sub-a01-42.long.domain> <user43@sub-a01-43.long.domain> <user44@sub-a01-44.long.domain> <user45@sub-a01-45.long.domain> <user46@sub-a01-46.long.domain> <user47@sub-a01-47.long.domain> <user48@sub-a01-48.long.domain> <user49@sub-a01-49.long.domain> <user50@sub-a01-50.long.domain> <user51@sub-a01-51.long.domain> <user52@sub-a01-52.long.domain> <user53@sub-a01-53.long.domain> <user54@sub-a01-54.long.domain> <user55@sub-a01-55.long.domain> <user56@sub-a01-56.long.domain> <user57@sub-a01-57.long.domain> <user58@sub-a01-58.long.domain> <user59@sub-a01-59.long.domain> <user60@sub-a01-60.long.domain> <user61@sub-a01-61.long.domain> <user62@sub-a01-62.long.domain> <user63@sub-a01-63.long.domain> <user64@sub-a01-64.long.domain> <user65@sub-a01-65.long.domain> <user66@sub-a01-66.long.domain> <user67@sub-a01-67.long.domain> <user68@sub-a01-68.long.domain> <user69@sub-a01-69.long.domain> <user70@sub-a01-70.long.domain> <user71@sub-a01-71.long.domain> <user72@sub-a01-72.long.domain> <user73@sub-a01-73.long.domain> <user74@sub-a01-74.long.domain> <user75@sub-a01-75.long.domain> <user76@sub-a01-76.long.domain> <user77@sub-a01-77.long.domain> <user78@sub-a01-78.long.domain> <user79@sub-a01-79.long.domain> <user80@sub-a01-80.long.domain> <user81@sub-a01-81.long.domain> <user82@sub-a01-82.long.domain> <user83@sub-a01-83.long.domain> <user84@sub-a01-84.long.domain> <user85@sub-a01-85.long.domain> <user86@sub-a01-86.long.domain> <user87@sub-a01-87.long.domain> <user88@sub-a01-88.long.domain> <user89@sub-a01-89.long.domain> <user90@sub-a01-90.long.domain> <user91@sub-a01-91.long.domain> <user92@sub-a01-92.long.domain> <user93@sub-a01-93.long.domain> <user94@sub-a01-94.long.domain> <user95@sub-a01-95.long.domain> <user96@sub-a01-96.long.domain> <user97@sub-a01-97.long.domain> <user98@sub-a01-98.long.domain> <user99@sub-a01-99.long.domain>
longsub-a02: <user0@sub-a02-0.long.domain> <user1@sub-a02-1.long.domain> <user2@sub-a02-2.long.domain> <user3@sub-a02-3.long.domain> <user4@sub-a02-4.long.domain> <user5@sub-a02-5.long.domain> <user6@sub-a02-6.long.domain> <user7@sub-a02-7.long.domain> <user8@sub-a02-8.long.domain> <user9@sub-a02-9.long.domain> <user10@sub-a02-10.long.domain> <user11@sub-a02-11.long.domain> <user12@sub-a02-12.long.domain> <user13@sub-a02-13.long.domain> <user14@sub-a02-14.long.domain> <user15@sub-a02-15.long.domain> <user16@sub-a02-16.long.domain> <user17@sub-a02-17.long.domain> <user18@sub-a02-18.long.domain> <user19@sub-a02-19.long.domain> <user20@sub-a02-20.long.domain> <user21@sub-a02-21.long.domain> <user22@sub-a02-22.long.domain> <user23@sub-a02-23.long.domain> <user24@sub-a02-24.long.domain> <user25@sub-a02-25.long.domain> <user26@sub-a02-26.long.domain> <user27@sub-a02-27.long.domain> <user28@sub-a02-28.long.domain> <user29@sub-a02-29.long.domain> <user30@sub-a02-30.long.domain> <user31@sub-a02-31.long.domain> <user32@sub-a02-32.long.domain> <user33@sub-a02-33.long.domain> <user34@sub-a02-34.long.domain> <user35@sub-a02-35.long.domain> <user36@sub-a02-36.long.domain> <user37@sub-a02-37.long.domain> <user38@sub-a02-38.long.domain> <user39@sub-a02-39.long.domain> <user40@sub-a02-40.long.domain> <user41@sub-a02-41.long.domain> <user42@sub-a02-42.long.domain> <user43@sub-a02-43.long.domain> <user44@sub-a02-44.long.domain> <user45@sub-a02-45.long.domain> <user46@sub-a02-46.long.domain> <user47@sub-a02-47.long.domain> <user48@sub-a02-48.long.domain> <user49@sub-a02-49.long.domain> <user50@sub-a02-50.long.domain> <user51@sub-a02-51.long.domain> <user52@sub-a02-52.long.domain> <user53@sub-a02-53.long.domain> <user54@sub-a02-54.long.domain> <user55@sub-a02-55.long.domain> <user56@sub-a02-56.long.domain> <user57@sub-a02-57.long.domain> <user58@sub-a02-58.long.domain> <user59@sub-a02-59.long.domain> <user60@sub-a02-60.long.domain> <user61@sub-a02-61.long.domain> <user62@sub-a02-62.long.domain> <user63@sub-a02-63.long.domain> <user64@sub-a02-64.long.domain> <user65@sub-a02-65.long.domain> <user66@sub-a02-66.long.domain> <user67@sub-a02-67.long.domain> <user68@sub-a02-68.long.domain> <user69@sub-a02-69.long.domain> <user70@sub-a02-70.long.domain> <user71@sub-a02-71.long.domain> <user72@sub-a02-72.long.domain> <user73@sub-a02-73.long.domain> <user74@sub-a02-74.long.domain> <user75@sub-a02-75.long.domain> <user76@sub-a02-76.long.domain> <user77@sub-a02-77.long.domain> <user78@sub-a02-78.long.domain> <user79@sub-a02-79.long.domain> <user80@sub-a02-80.long.domain> <user81@sub-a02-81.long.domain> <user82@sub-a02-82.long.domain> <user83@sub-a02-83.long.domain> <user84@sub-a02-84.long.domain> <user85@sub-a02-85.long.domain> <user86@sub-a02-86.long.domain> <user87@sub-a02-87.long.domain> <user88@sub-a02-88.long.domain> <user89@sub-a02-89.long.domain> <user90@sub-a02-90.long.domain> <user91@sub-a02-91.long.domain> <user92@sub-a02-92.long.domain> <user93@sub-a02-93.long.domain> <user94@sub-a02-94.long.domain> <user95@sub-a02-95.long.domain> <user96@sub-a02-96.long.domain> <user97@sub-a02-97.long.domain> <user98@sub-a02-98.long.domain> <user99@sub-a02-99.long.domain>
longsub-a03: <user0@sub-a03-0.long.domain> <user1@sub-a03-1.long.domain> <user2@sub-a03-2.long.domain> <user3@sub-a03-3.long.domain> <user4@sub-a03-4.long.domain> <user5@sub-a03-5.long.domain> <user6@sub-a03-6.long.domain> <user7@sub-a03-7.long.domain> <user8@sub-a03-8.long.domain> <user9@sub-a03-9.long.domain> <user10@sub-a03-10.long.domain> <user11@sub-a03-11.long.domain> <user12@sub-a03-12.long.domain> <user13@sub-a03-13.long.domain> <user14@sub-a03-14.long.domain> <user15@sub-a03-15.long.domain> <user16@sub-a03-16.long.domain> <user17@sub-a03-17.long.domain> <user18@sub-a03-18.long.domain> <user19@sub-a03-19.long.domain> <user20@sub-a03-20.long.domain> <user21@sub-a03-21.long.domain> <user22@sub-a03-22.long.domain> <user23@sub-a03-23.long.domain> <user24@sub-a03-24.long.domain> <user25@sub-a03-25.long.domain> <user26@sub-a03-26.long.domain> <user27@sub-a03-27.long.domain> <user28@sub-a03-28.long.domain> <user29@sub-a03-29.long.domain> <user30@sub-a03-30.long.domain> <user31@sub-a03-31.long.domain> <user32@sub-a03-32.long.domain> <user33@sub-a03-33.long.domain> <user34@sub-a03-34.long.domain> <user35@sub-a03-35.long.domain> <user36@sub-a03-36.long.domain> <user37@sub-a03-37.long.domain> <user38@sub-a03-38.long.domain> <user39@sub-a03-39.long.domain> <user40@sub-a03-40.long.domain> <user41@sub-a03-41.long.domain> <user42@sub-a03-42.long.domain> <user43@sub-a03-43.long.domain> <user44@sub-a03-44.long.domain> <user45@sub-a03-45.long.domain> <user46@sub-a03-46.long.domain> <user47@sub-a03-47.long.domain> <user48@sub-a03-48.long.domain> <user49@sub-a03-49.long.domain> <user50@sub-a03-50.long.domain> <user51@sub-a03-51.long.domain> <user52@sub-a03-52.long.domain> <user53@sub-a03-53.long.domain> <user54@sub-a03-54.long.domain> <user55@sub-a03-55.long.domain> <user56@sub-a03-56.long.domain> <user57@sub-a03-57.long.domain> <user58@sub-a03-58.long.domain> <user59@sub-a03-59.long.domain> <user60@sub-a03-60.long.domain> <user61@sub-a03-61.long.domain> <user62@sub-a03-62.long.domain> <user63@sub-a03-63.long.domain> <user64@sub-a03-64.long.domain> <user65@sub-a03-65.long.domain> <user66@sub-a03-66.long.domain> <user67@sub-a03-67.long.domain> <user68@sub-a03-68.long.domain> <user69@sub-a03-69.long.domain> <user70@sub-a03-70.long.domain> <user71@sub-a03-71.long.domain> <user72@sub-a03-72.long.domain> <user73@sub-a03-73.long.domain> <user74@sub-a03-74.long.domain> <user75@sub-a03-75.long.domain> <user76@sub-a03-76.long.domain> <user77@sub-a03-77.long.domain> <user78@sub-a03-78.long.domain> <user79@sub-a03-79.long.domain> <user80@sub-a03-80.long.domain> <user81@sub-a03-81.long.domain> <user82@sub-a03-82.long.domain> <user83@sub-a03-83.long.domain> <user84@sub-a03-84.long.domain> <user85@sub-a03-85.long.domain> <user86@sub-a03-86.long.domain> <user87@sub-a03-87.long.domain> <user88@sub-a03-88.long.domain> <user89@sub-a03-89.long.domain> <user90@sub-a03-90.long.domain> <user91@sub-a03-91.long.domain> <user92@sub-a03-92.long.domain> <user93@sub-a03-93.long.domain> <user94@sub-a03-94.long.domain> <user95@sub-a03-95.long.domain> <user96@sub-a03-96.long.domain> <user97@sub-a03-97.long.domain> <user98@sub-a03-98.long.domain> <user99@sub-a03-99.long.domain>
longsub-a04: <user0@sub-a04-0.long.domain> <user1@sub-a04-1.long.domain> <user2@sub-a04-2.long.domain> <user3@sub-a04-3.long.domain> <user4@sub-a04-4.long.domain> <user5@sub-a04-5.long.domain> <user6@sub-a04-6.long.domain> <user7@sub-a04-7.long.domain> <user8@sub-a04-8.long.domain> <user9@sub-a04-9.long.domain> <user10@sub-a04-10.long.domain> <user11@sub-a04-11.long.domain> <user12@sub-a04-12.long.domain> <user13@sub-a04-13.long.domain> <user14@sub-a04-14.long.domain> <user15@sub-a04-15.long.domain> <user16@sub-a04-16.long.domain> <user17@sub-a04-17.long.domain> <user18@sub-a04-18.long.domain> <user19@sub-a04-19.long.domain> <user20@sub-a04-20.long.domain> <user21@sub-a04-21.long.domain> <user22@sub-a04-22.long.domain> <user23@sub-a04-23.long.domain> <user24@sub-a04-24.long.domain> <user25@sub-a04-25.long.domain> <user26@sub-a04-26.long.domain> <user27@sub-a04-27.long.domain> <user28@sub-a04-28.long.domain> <user29@sub-a04-29.long.domain> <user30@sub-a04-30.long.domain> <user31@sub-a04-31.long.domain> <user32@sub-a04-32.long.domain> <user33@sub-a04-33.long.domain> <user34@sub-a04-34.long.domain> <user35@sub-a04-35.long.domain> <user36@sub-a04-36.long.domain> <user37@sub-a04-37.long.domain> <user38@sub-a04-38.long.domain> <user39@sub-a04-39.long.domain> <user40@sub-a04-40.long.domain> <user41@sub-a04-41.long.domain> <user42@sub-a04-42.long.domain> <user43@sub-a04-43.long.domain> <user44@sub-a04-44.long.domain> <user45@sub-a04-45.long.domain> <user46@sub-a04-46.long.domain> <user47@sub-a04-47.long.domain> <user48@sub-a04-48.long.domain> <user49@sub-a04-49.long.domain> <user50@sub-a04-50.long.domain> <user51@sub-a04-51.long.domain> <user52@sub-a04-52.long.domain> <user53@sub-a04-53.long.domain> <user54@sub-a04-54.long.domain> <user55@sub-a04-55.long.domain> <user56@sub-a04-56.long.domain> <user57@sub-a04-57.long.domain> <user58@sub-a04-58.long.domain> <user59@sub-a04-59.long.domain> <user60@sub-a04-60.long.domain> <user61@sub-a04-61.long.domain> <user62@sub-a04-62.long.domain> <user63@sub-a04-63.long.domain> <user64@sub-a04-64.long.domain> <user65@sub-a04-65.long.domain> <user66@sub-a04-66.long.domain> <user67@sub-a04-67.long.domain> <user68@sub-a04-68.long.domain> <user69@sub-a04-69.long.domain> <user70@sub-a04-70.long.domain> <user71@sub-a04-71.long.domain> <user72@sub-a04-72.long.domain> <user73@sub-a04-73.long.domain> <user74@sub-a04-74.long.domain> <user75@sub-a04-75.long.domain> <user76@sub-a04-76.long.domain> <user77@sub-a04-77.long.domain> <user78@sub-a04-78.long.domain> <user79@sub-a04-79.long.domain> <user80@sub-a04-80.long.domain> <user81@sub-a04-81.long.domain> <user82@sub-a04-82.long.domain> <user83@sub-a04-83.long.domain> <user84@sub-a04-84.long.domain> <user85@sub-a04-85.long.domain> <user86@sub-a04-86.long.domain> <user87@sub-a04-87.long.domain> <user88@sub-a04-88.long.domain> <user89@sub-a04-89.long.domain> <user90@sub-a04-90.long.domain> <user91@sub-a04-91.long.domain> <user92@sub-a04-92.long.domain> <user93@sub-a04-93.long.domain> <user94@sub-a04-94.long.domain> <user95@sub-a04-95.long.domain> <user96@sub-a04-96.long.domain> <user97@sub-a04-97.long.domain> <user98@sub-a04-98.long.domain> <user99@sub-a04-99.long.domain>
longsub-a05: <user0@sub-a05-0.long.domain> <user1@sub-a05-1.long.domain> <user2@sub-a05-2.long.domain> <user3@sub-a05-3.long.domain> <user4@sub-a05-4.long.domain> <user5@sub-a05-5.long.domain> <user6@sub-a05-6.long.domain> <user7@sub-a05-7.long.domain> <user8@sub-a05-8.long.domain> <user9@sub-a05-9.long.domain> <user10@sub-a05-10.long.domain> <user11@sub-a05-11.long.domain> <user12@sub-a05-12.long.domain> <user13@sub-a05-13.long.domain> <user14@sub-a05-14.long.domain> <user15@sub-a05-15.long.domain> <user16@sub-a05-16.long.domain> <user17@sub-a05-17.long.domain> <user18@sub-a05-18.long.domain> <user19@sub-a05-19.long.domain> <user20@sub-a05-20.long.domain> <user21@sub-a05-21.long.domain> <user22@sub-a05-22.long.domain> <user23@sub-a05-23.long.domain> <user24@sub-a05-24.long.domain> <user25@sub-a05-25.long.domain> <user26@sub-a05-26.long.domain> <user27@sub-a05-27.long.domain> <user28@sub-a05-28.long.domain> <user29@sub-a05-29.long.domain> <user30@sub-a05-30.long.domain> <user31@sub-a05-31.long.domain> <user32@sub-a05-32.long.domain> <user33@sub-a05-33.long.domain> <user34@sub-a05-34.long.domain> <user35@sub-a05-35.long.domain> <user36@sub-a05-36.long.domain> <user37@sub-a05-37.long.domain> <user38@sub-a05-38.long.domain> <user39@sub-a05-39.long.domain> <user40@sub-a05-40.long.domain> <user41@sub-a05-41.long.domain> <user42@sub-a05-42.long.domain> <user43@sub-a05-43.long.domain> <user44@sub-a05-44.long.domain> <user45@sub-a05-45.long.domain> <user46@sub-a05-46.long.domain> <user47@sub-a05-47.long.domain> <user48@sub-a05-48.long.domain> <user49@sub-a05-49.long.domain> <user50@sub-a05-50.long.domain> <user51@sub-a05-51.long.domain> <user52@sub-a05-52.long.domain> <user53@sub-a05-53.long.domain> <user54@sub-a05-54.long.domain> <user55@sub-a05-55.long.domain> <user56@sub-a05-56.long.domain> <user57@sub-a05-57.long.domain> <user58@sub-a05-58.long.domain> <user59@sub-a05-59.long.domain> <user60@sub-a05-60.long.domain> <user61@sub-a05-61.long.domain> <user62@sub-a05-62.long.domain> <user63@sub-a05-63.long.domain> <user64@sub-a05-64.long.domain> <user65@sub-a05-65.long.domain> <user66@sub-a05-66.long.domain> <user67@sub-a05-67.long.domain> <user68@sub-a05-68.long.domain> <user69@sub-a05-69.long.domain> <user70@sub-a05-70.long.domain> <user71@sub-a05-71.long.domain> <user72@sub-a05-72.long.domain> <user73@sub-a05-73.long.domain> <user74@sub-a05-74.long.domain> <user75@sub-a05-75.long.domain> <user76@sub-a05-76.long.domain> <user77@sub-a05-77.long.domain> <user78@sub-a05-78.long.domain> <user79@sub-a05-79.long.domain> <user80@sub-a05-80.long.domain> <user81@sub-a05-81.long.domain> <user82@sub-a05-82.long.domain> <user83@sub-a05-83.long.domain> <user84@sub-a05-84.long.domain> <user85@sub-a05-85.long.domain> <user86@sub-a05-86.long.domain> <user87@sub-a05-87.long.domain> <user88@sub-a05-88.long.domain> <user89@sub-a05-89.long.domain> <user90@sub-a05-90.long.domain> <user91@sub-a05-91.long.domain> <user92@sub-a05-92.long.domain> <user93@sub-a05-93.long.domain> <user94@sub-a05-94.long.domain> <user95@sub-a05-95.long.domain> <user96@sub-a05-96.long.domain> <user97@sub-a05-97.long.domain> <user98@sub-a05-98.long.domain> <user99@sub-a05-99.long.domain>
longsub-a06: <user0@sub-a06-0.long.domain> <user1@sub-a06-1.long.domain> <user2@sub-a06-2.long.domain> <user3@sub-a06-3.long.domain> <user4@sub-a06-4.long.domain> <user5@sub-a06-5.long.domain> <user6@sub-a06-6.long.domain> <user7@sub-a06-7.long.domain> <user8@sub-a06-8.long.domain> <user9@sub-a06-9.long.domain> <user10@sub-a06-10.long.domain> <user11@sub-a06-11.long.domain> <user12@sub-a06-12.long.domain> <user13@sub-a06-13.long.domain> <user14@sub-a06-14.long.domain> <user15@sub-a06-15.long.domain> <user16@sub-a06-16.long.domain> <user17@sub-a06-17.long.domain> <user18@sub-a06-18.long.domain> <user19@sub-a06-19.long.domain> <user20@sub-a06-20.long.domain> <user21@sub-a06-21.long.domain> <user22@sub-a06-22.long.domain> <user23@sub-a06-23.long.domain> <user24@sub-a06-24.long.domain> <user25@sub-a06-25.long.domain> <user26@sub-a06-26.long.domain> <user27@sub-a06-27.long.domain> <user28@sub-a06-28.long.domain> <user29@sub-a06-29.long.domain> <user30@sub-a06-30.long.domain> <user31@sub-a06-31.long.domain> <user32@sub-a06-32.long.domain> <user33@sub-a06-33.long.domain> <user34@sub-a06-34.long.domain> <user35@sub-a06-35.long.domain> <user36@sub-a06-36.long.domain> <user37@sub-a06-37.long.domain> <user38@sub-a06-38.long.domain> <user39@sub-a06-39.long.domain> <user40@sub-a06-40.long.domain> <user41@sub-a06-41.long.domain> <user42@sub-a06-42.long.domain> <user43@sub-a06-43.long.domain> <user44@sub-a06-44.long.domain> <user45@sub-a06-45.long.domain> <user46@sub-a06-46.long.domain> <user47@sub-a06-47.long.domain> <user48@sub-a06-48.long.domain> <user49@sub-a06-49.long.domain> <user50@sub-a06-50.long.domain> <user51@sub-a06-51.long.domain> <user52@sub-a06-52.long.domain> <user53@sub-a06-53.long.domain> <user54@sub-a06-54.long.domain> <user55@sub-a06-55.long.domain> <user56@sub-a06-56.long.domain> <user57@sub-a06-57.long.domain> <user58@sub-a06-58.long.domain> <user59@sub-a06-59.long.domain> <user60@sub-a06-60.long.domain> <user61@sub-a06-61.long.domain> <user62@sub-a06-62.long.domain> <user63@sub-a06-63.long.domain> <user64@sub-a06-64.long.domain> <user65@sub-a06-65.long.domain> <user66@sub-a06-66.long.domain> <user67@sub-a06-67.long.domain> <user68@sub-a06-68.long.domain> <user69@sub-a06-69.long.domain> <user70@sub-a06-70.long.domain> <user71@sub-a06-71.long.domain> <user72@sub-a06-72.long.domain> <user73@sub-a06-73.long.domain> <user74@sub-a06-74.long.domain> <user75@sub-a06-75.long.domain> <user76@sub-a06-76.long.domain> <user77@sub-a06-77.long.domain> <user78@sub-a06-78.long.domain> <user79@sub-a06-79.long.domain> <user80@sub-a06-80.long.domain> <user81@sub-a06-81.long.domain> <user82@sub-a06-82.long.domain> <user83@sub-a06-83.long.domain> <user84@sub-a06-84.long.domain> <user85@sub-a06-85.long.domain> <user86@sub-a06-86.long.domain> <user87@sub-a06-87.long.domain> <user88@sub-a06-88.long.domain> <user89@sub-a06-89.long.domain> <user90@sub-a06-90.long.domain> <user91@sub-a06-91.long.domain> <user92@sub-a06-92.long.domain> <user93@sub-a06-93.long.domain> <user94@sub-a06-94.long.domain> <user95@sub-a06-95.long.domain> <user96@sub-a06-96.long.domain> <user97@sub-a06-97.long.domain> <user98@sub-a06-98.long.domain> <user99@sub-a06-99.long.domain>
longsub-a07: <user0@sub-a07-0.long.domain> <user1@sub-a07-1.long.domain> <user2@sub-a07-2.long.domain> <user3@sub-a07-3.long.domain> <user4@sub-a07-4.long.domain> <user5@sub-a07-5.long.domain> <user6@sub-a07-6.long.domain> <user7@sub-a07-7.long.domain> <user8@sub-a07-8.long.domain> <user9@sub-a07-9.long.domain> <user10@sub-a07-10.long.domain> <user11@sub-a07-11.long.domain> <user12@sub-a07-12.long.domain> <user13@sub-a07-13.long.domain> <user14@sub-a07-14.long.domain> <user15@sub-a07-15.long.domain> <user16@sub-a07-16.long.domain> <user17@sub-a07-17.long.domain> <user18@sub-a07-18.long.domain> <user19@sub-a07-19.long.domain> <user20@sub-a07-20.long.domain> <user21@sub-a07-21.long.domain> <user22@sub-a07-22.long.domain> <user23@sub-a07-23.long.domain> <user24@sub-a07-24.long.domain> <user25@sub-a07-25.long.domain> <user26@sub-a07-26.long.domain> <user27@sub-a07-27.long.domain> <user28@sub-a07-28.long.domain> <user29@sub-a07-29.long.domain> <user30@sub-a07-30.long.domain> <user31@sub-a07-31.long.domain> <user32@sub-a07-32.long.domain> <user33@sub-a07-33.long.domain> <user34@sub-a07-34.long.domain> <user35@sub-a07-35.long.domain> <user36@sub-a07-36.long.domain> <user37@sub-a07-37.long.domain> <user38@sub-a07-38.long.domain> <user39@sub-a07-39.long.domain> <user40@sub-a07-40.long.domain> <user41@sub-a07-41.long.domain> <user42@sub-a07-42.long.domain> <user43@sub-a07-43.long.domain> <user44@sub-a07-44.long.domain> <user45@sub-a07-45.long.domain> <user46@sub-a07-46.long.domain> <user47@sub-a07-47.long.domain> <user48@sub-a07-48.long.domain> <user49@sub-a07-49.long.domain> <user50@sub-a07-50.long.domain> <user51@sub-a07-51.long.domain> <user52@sub-a07-52.long.domain> <user53@sub-a07-53.long.domain> <user54@sub-a07-54.long.domain> <user55@sub-a07-55.long.domain> <user56@sub-a07-56.long.domain> <user57@sub-a07-57.long.domain> <user58@sub-a07-58.long.domain> <user59@sub-a07-59.long.domain> <user60@sub-a07-60.long.domain> <user61@sub-a07-61.long.domain> <user62@sub-a07-62.long.domain> <user63@sub-a07-63.long.domain> <user64@sub-a07-64.long.domain> <user65@sub-a07-65.long.domain> <user66@sub-a07-66.long.domain> <user67@sub-a07-67.long.domain> <user68@sub-a07-68.long.domain> <user69@sub-a07-69.long.domain> <user70@sub-a07-70.long.domain> <user71@sub-a07-71.long.domain> <user72@sub-a07-72.long.domain> <user73@sub-a07-73.long.domain> <user74@sub-a07-74.long.domain> <user75@sub-a07-75.long.domain> <user76@sub-a07-76.long.domain> <user77@sub-a07-77.long.domain> <user78@sub-a07-78.long.domain> <user79@sub-a07-79.long.domain> <user80@sub-a07-80.long.domain> <user81@sub-a07-81.long.domain> <user82@sub-a07-82.long.domain> <user83@sub-a07-83.long.domain> <user84@sub-a07-84.long.domain> <user85@sub-a07-85.long.domain> <user86@sub-a07-86.long.domain> <user87@sub-a07-87.long.domain> <user88@sub-a07-88.long.domain> <user89@sub-a07-89.long.domain> <user90@sub-a07-90.long.domain> <user91@sub-a07-91.long.domain> <user92@sub-a07-92.long.domain> <user93@sub-a07-93.long.domain> <user94@sub-a07-94.long.domain> <user95@sub-a07-95.long.domain> <user96@sub-a07-96.long.domain> <user97@sub-a07-97.long.domain> <user98@sub-a07-98.long.domain> <user99@sub-a07-99.long.domain>
longsub-a08: <user0@sub-a08-0.long.domain> <user1@sub-a08-1.long.domain> <user2@sub-a08-2.long.domain> <user3@sub-a08-3.long.domain> <user4@sub-a08-4.long.domain> <user5@sub-a08-5.long.domain> <user6@sub-a08-6.long.domain> <user7@sub-a08-7.long.domain> <user8@sub-a08-8.long.domain> <user9@sub-a08-9.long.domain> <user10@sub-a08-10.long.domain> <user11@sub-a08-11.long.domain> <user12@sub-a08-12.long.domain> <user13@sub-a08-13.long.domain> <user14@sub-a08-14.long.domain> <user15@sub-a08-15.long.domain> <user16@sub-a08-16.long.domain> <user17@sub-a08-17.long.domain> <user18@sub-a08-18.long.domain> <user19@sub-a08-19.long.domain> <user20@sub-a08-20.long.domain> <user21@sub-a08-21.long.domain> <user22@sub-a08-22.long.domain> <user23@sub-a08-23.long.domain> <user24@sub-a08-24.long.domain> <user25@sub-a08-25.long.domain> <user26@sub-a08-26.long.domain> <user27@sub-a08-27.long.domain> <user28@sub-a08-28.long.domain> <user29@sub-a08-29.long.domain> <user30@sub-a08-30.long.domain> <user31@sub-a08-31.long.domain> <user32@sub-a08-32.long.domain> <user33@sub-a08-33.long.domain> <user34@sub-a08-34.long.domain> <user35@sub-a08-35.long.domain> <user36@sub-a08-36.long.domain> <user37@sub-a08-37.long.domain> <user38@sub-a08-38.long.domain> <user39@sub-a08-39.long.domain> <user40@sub-a08-40.long.domain> <user41@sub-a08-41.long.domain> <user42@sub-a08-42.long.domain> <user43@sub-a08-43.long.domain> <user44@sub-a08-44.long.domain> <user45@sub-a08-45.long.domain> <user46@sub-a08-46.long.domain> <user47@sub-a08-47.long.domain> <user48@sub-a08-48.long.domain> <user49@sub-a08-49.long.domain> <user50@sub-a08-50.long.domain> <user51@sub-a08-51.long.domain> <user52@sub-a08-52.long.domain> <user53@sub-a08-53.long.domain> <user54@sub-a08-54.long.domain> <user55@sub-a08-55.long.domain> <user56@sub-a08-56.long.domain> <user57@sub-a08-57.long.domain> <user58@sub-a08-58.long.domain> <user59@sub-a08-59.long.domain> <user60@sub-a08-60.long.domain> <user61@sub-a08-61.long.domain> <user62@sub-a08-62.long.domain> <user63@sub-a08-63.long.domain> <user64@sub-a08-64.long.domain> <user65@sub-a08-65.long.domain> <user66@sub-a08-66.long.domain> <user67@sub-a08-67.long.domain> <user68@sub-a08-68.long.domain> <user69@sub-a08-69.long.domain> <user70@sub-a08-70.long.domain> <user71@sub-a08-71.long.domain> <user72@sub-a08-72.long.domain> <user73@sub-a08-73.long.domain> <user74@sub-a08-74.long.domain> <user75@sub-a08-75.long.domain> <user76@sub-a08-76.long.domain> <user77@sub-a08-77.long.domain> <user78@sub-a08-78.long.domain> <user79@sub-a08-79.long.domain> <user80@sub-a08-80.long.domain> <user81@sub-a08-81.long.domain> <user82@sub-a08-82.long.domain> <user83@sub-a08-83.long.domain> <user84@sub-a08-84.long.domain> <user85@sub-a08-85.long.domain> <user86@sub-a08-86.long.domain> <user87@sub-a08-87.long.domain> <user88@sub-a08-88.long.domain> <user89@sub-a08-89.long.domain> <user90@sub-a08-90.long.domain> <user91@sub-a08-91.long.domain> <user92@sub-a08-92.long.domain> <user93@sub-a08-93.long.domain> <user94@sub-a08-94.long.domain> <user95@sub-a08-95.long.domain> <user96@sub-a08-96.long.domain> <user97@sub-a08-97.long.domain> <user98@sub-a08-98.long.domain> <user99@sub-a08-99.long.domain>
longsub-a09: <user0@sub-a09-0.long.domain> <user1@sub-a09-1.long.domain> <user2@sub-a09-2.long.domain> <user3@sub-a09-3.long.domain> <user4@sub-a09-4.long.domain> <user5@sub-a09-5.long.domain> <user6@sub-a09-6.long.domain> <user7@sub-a09-7.long.domain> <user8@sub-a09-8.long.domain> <user9@sub-a09-9.long.domain> <user10@sub-a09-10.long.domain> <user11@sub-a09-11.long.domain> <user12@sub-a09-12.long.domain> <user13@sub-a09-13.long.domain> <user14@sub-a09-14.long.domain> <user15@sub-a09-15.long.domain> <user16@sub-a09-16.long.domain> <user17@sub-a09-17.long.domain> <user18@sub-a09-18.long.domain> <user19@sub-a09-19.long.domain> <user20@sub-a09-20.long.domain> <user21@sub-a09-21.long.domain> <user22@sub-a09-22.long.domain> <user23@sub-a09-23.long.domain> <user24@sub-a09-24.long.domain> <user25@sub-a09-25.long.domain> <user26@sub-a09-26.long.domain> <user27@sub-a09-27.long.domain> <user28@sub-a09-28.long.domain> <user29@sub-a09-29.long.domain> <user30@sub-a09-30.long.domain> <user31@sub-a09-31.long.domain> <user32@sub-a09-32.long.domain> <user33@sub-a09-33.long.domain> <user34@sub-a09-34.long.domain> <user35@sub-a09-35.long.domain> <user36@sub-a09-36.long.domain> <user37@sub-a09-37.long.domain> <user38@sub-a09-38.long.domain> <user39@sub-a09-39.long.domain> <user40@sub-a09-40.long.domain> <user41@sub-a09-41.long.domain> <user42@sub-a09-42.long.domain> <user43@sub-a09-43.long.domain> <user44@sub-a09-44.long.domain> <user45@sub-a09-45.long.domain> <user46@sub-a09-46.long.domain> <user47@sub-a09-47.long.domain> <user48@sub-a09-48.long.domain> <user49@sub-a09-49.long.domain> <user50@sub-a09-50.long.domain> <user51@sub-a09-51.long.domain> <user52@sub-a09-52.long.domain> <user53@sub-a09-53.long.domain> <user54@sub-a09-54.long.domain> <user55@sub-a09-55.long.domain> <user56@sub-a09-56.long.domain> <user57@sub-a09-57.long.domain> <user58@sub-a09-58.long.domain> <user59@sub-a09-59.long.domain> <user60@sub-a09-60.long.domain> <user61@sub-a09-61.long.domain> <user62@sub-a09-62.long.domain> <user63@sub-a09-63.long.domain> <user64@sub-a09-64.long.domain> <user65@sub-a09-65.long.domain> <user66@sub-a09-66.long.domain> <user67@sub-a09-67.long.domain> <user68@sub-a09-68.long.domain> <user69@sub-a09-69.long.domain> <user70@sub-a09-70.long.domain> <user71@sub-a09-71.long.domain> <user72@sub-a09-72.long.domain> <user73@sub-a09-73.long.domain> <user74@sub-a09-74.long.domain> <user75@sub-a09-75.long.domain> <user76@sub-a09-76.long.domain> <user77@sub-a09-77.long.domain> <user78@sub-a09-78.long.domain> <user79@sub-a09-79.long.domain> <user80@sub-a09-80.long.domain> <user81@sub-a09-81.long.domain> <user82@sub-a09-82.long.domain> <user83@sub-a09-83.long.domain> <user84@sub-a09-84.long.domain> <user85@sub-a09-85.long.domain> <user86@sub-a09-86.long.domain> <user87@sub-a09-87.long.domain> <user88@sub-a09-88.long.domain> <user89@sub-a09-89.long.domain> <user90@sub-a09-90.long.domain> <user91@sub-a09-91.long.domain> <user92@sub-a09-92.long.domain> <user93@sub-a09-93.long.domain> <user94@sub-a09-94.long.domain> <user95@sub-a09-95.long.domain> <user96@sub-a09-96.long.domain> <user97@sub-a09-97.long.domain> <user98@sub-a09-98.long.domain> <user99@sub-a09-99.long.domain>
longsub-a00-a09: <longsub-a00@local.dom> <longsub-a01@local.dom> <longsub-a02@local.dom> <longsub-a03@local.dom> <longsub-a04@local.dom> <longsub-a05@local.dom> <longsub-a06@local.dom> <longsub-a07@local.dom> <longsub-a08@local.dom> <longsub-a09@local.dom>
EOF
# create map
rm -f ${ALIMAP}
${MM} < ${ALI}

# create mailertable (save old version?)
${CAT} > ${MT} <<EOF
local.dom	lmtp:
alsolocal.dom	lmtp:
some.dom	[127.0.0.1]
remote.dom	[127.0.0.1]
long.domain	[127.0.0.1]
.long.domain	[127.0.0.1]
EOF

# ----------------------------------------
${CAT} > ${SMXCNF} <<EOF
qmgr { Log_Level = 12; wait_for_server=4; wait_for_client=4;
}
smar {
aliases { flags = local_domains; }
Log_Level = 12;
nameserver = ${NS};
DNS_timeout = 5;
}
smtpc { Log_Level = 12; remote_port=${SNKPORT}; wait_for_server=4; }
smtps {
Log_Level = 14;
daemon_address = localhost:${SRVPORT};
wait_for_server=4;
}
EOF


# ----------------------------------------
# test: send mail to long list
TEST=1
if echo " ${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false

if ${SHELL} ${SD}/smtpcnf.sh -Ssender+${TEST}@local.dom -Rlong@local.dom -E 100 -X 1 -A 1
then
  :
else
  ERR=true
fi
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${SM_STOPONERROR}" != X && exit 1
fi
else
  ${VERBOSE} && echo "$0: test ${TEST} SKIPPED"
fi

# ----------------------------------------
# test: send mail to long list
TEST=2
if echo " ${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false

if ${SHELL} ${SD}/smtpcnf.sh -Ssender+${TEST}@local.dom -Rlongsome@local.dom -E 100 -X 1 -A 1
then
  :
else
  ERR=true
fi
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${SM_STOPONERROR}" != X && exit 1
fi
else
  ${VERBOSE} && echo "$0: test ${TEST} SKIPPED"
fi

# ----------------------------------------
# test: send mail to long list
TEST=3
if echo " ${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false

if ${SHELL} ${SD}/smtpcnf.sh -Ssender+${TEST}@local.dom -Rlongsub@local.dom -E 100 -X 1 -A 1
then
  :
else
  ERR=true
fi
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${SM_STOPONERROR}" != X && exit 1
fi
else
  ${VERBOSE} && echo "$0: test ${TEST} SKIPPED"
fi

# ----------------------------------------
# test: send mail to long list
TEST=4
if echo " ${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false

if ${SHELL} ${SD}/smtpcnf.sh -Ssender+${TEST}@local.dom -Rlong+some@local.dom -E 200 -X 1 -A 1
then
  :
else
  ERR=true
fi
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${SM_STOPONERROR}" != X && exit 1
fi
else
  ${VERBOSE} && echo "$0: test ${TEST} SKIPPED"
fi


# ----------------------------------------
# test: send mail to long list
TEST=5
if echo " ${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false

if ${SHELL} ${SD}/smtpcnf.sh -Ssender+${TEST}@local.dom -Rlong+sub+some@local.dom -E 300 -X 1 -A 1
then
  :
else
  ERR=true
fi
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${SM_STOPONERROR}" != X && exit 1
fi
else
  ${VERBOSE} && echo "$0: test ${TEST} SKIPPED"
fi

# ----------------------------------------
# test: send mail to really long list
TEST=6
if echo " ${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false

if ${SHELL} ${SD}/smtpcnf.sh -1 -s 20 -d 1 -Ssender+${TEST}@local.dom -Rlongsub-a00-a09@local.dom -E 1000 -X 1 -A 1
then
  :
else
  ERR=true
fi
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${SM_STOPONERROR}" != X && exit 1
fi
else
  ${VERBOSE} && echo "$0: test ${TEST} SKIPPED"
fi


# ----------------------------------------
# test: send mail to really long list, restrict number of rcpts per TA
TEST=7
if echo " ${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false

# ----------------------------------------
${CAT} > ${SMXCNF} <<EOF
qmgr { Log_Level = 12; wait_for_server=4; wait_for_client=4;
smtpc { smtp_max_rcpts_per_transaction=100; }
}
smar {
aliases { flags = local_domains; }
Log_Level = 12;
nameserver = ${NS};
DNS_timeout = 5;
}
smtpc { Log_Level = 12; remote_port=${SNKPORT}; wait_for_server=4; }
smtps {
Log_Level = 14;
daemon_address = localhost:${SRVPORT};
wait_for_server=4;
}
EOF

if ${SHELL} ${SD}/smtpcnf.sh -1 -s 20 -d 2 -Ssender+${TEST}@local.dom -Rlongsub-a00-a09@local.dom -E 1000 -X 10 -A 1
then
  :
else
  ERR=true
fi
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${SM_STOPONERROR}" != X && exit 1
fi
else
  ${VERBOSE} && echo "$0: test ${TEST} SKIPPED"
fi


rm -f ${MTMAP} ${ALIMAP}
# ----------------------------------------
# end
if test "${ERRS}" = "0"
then
  exit 0
else
  echo "${ERRS} error(s)"
  exit 1
fi
