/*
 * Copyright (c) 2005 Sendmail, Inc. and its suppliers.
 *	All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 *
 * $Id: das.h,v 1.1 2005/08/15 17:06:46 ca Exp $
 */

#ifndef SM_DAS_H
#define SM_DAS_H 1
#include "sm/generic.h"

/*
**  This file includes some information that is shared between
**  qmgr, smar, and smtpc (or other "Deliver Agents").
*/

/*
**  Valid values for da_idx.
**  Currently da_idx is only used to select a protocol,
**  later on it should select a "Delivery Agent" which may have
**  more properties and can be defined in the configuration file.
**  See the documentation about the possible problems.
*/

#define DA_IDX_ESMTP		0	/* MUST be 0: default */
#define DA_IDX_LMTP_UNIX	1	/* lmtp over UNIX domain socket */
#define DA_IDX_LMTP_INET	2	/* lmtp over inet(v4) socket */

#if DA_IDX_ESMTP != 0
 ERROR: DA_IDX_ESMTP_ != 0
#endif

#endif /* SM_DAS_H */
