/*
 * Copyright (c) 2004, 2005 Sendmail, Inc. and its suppliers.
 *      All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 *
 *	$Id: sm-conf-prt.h,v 1.8 2005/08/17 22:17:42 ca Exp $
 */

#ifndef SM_CONF_PRT_H
#define SM_CONF_PRT_H 1

#include "sm/generic.h"
#include "sm/error.h"
#include "sm/sm-conf.h"
#include "sm/io.h"

#define SMC_FLD_FLAGS	0x0001	/* print also all flags */

void		sm_prt_conferr(const char *_fn, sm_conf_T *_smc, int _err);
void		sm_conf_dump_root(sm_conf_T *_stream, sm_conf_node_T *_node, sm_file_T *_fp);
sm_ret_T	sm_conf_dump_entry(sm_conf_T *_stream, sm_conf_node_T *_node, int _indent, sm_file_T *_fp);

int		sm_conf_prt_defs(const sm_conf_definition_T *_defs, uint _flags, sm_file_T *_fp, int _indent, sm_str_P _text);
sm_ret_T	sm_conf_prt_dflt(const sm_conf_definition_T *_defs, uint _flags, sm_file_T *_fp);

int		sm_conf_prt_conf(const sm_conf_definition_T *_defs, const void *_cnf, sm_file_T *_fp);
int		sm_conf_prt_cnfs(const sm_conf_definition_T *_defs, const void *_cnf, ptrdiff_t _offset, sm_file_T *_fp, int _indent, sm_str_P _prefix, sm_str_P _text);

#endif /* SM_CONF_PRT_H */
