/*
 * Copyright (c) 2004, 2005 Sendmail, Inc. and its suppliers.
 *	All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 *
 * $Id: smtpsh.h,v 1.5 2005/08/30 23:18:53 ca Exp $
 */

#ifndef SMTPSH_H
#define SMTPSH_H 1

#include "sm/generic.h"
#include "sm/types.h"
#include "smtps-str.h"

/* size for SMTP communication buffers */
#define SMTPBUFSIZE	1024
#define SMTPMAXSIZE	4096
#define SMTPMSGIDSIZE	256

/* maximum number of arguments for commands */
#define SS_MAX_ARGS	8

sm_ret_T ss_hdl_session(ss_sess_P _sess, sm_ret_T _sessok);
sm_ret_T ss_sess_new(ss_ctx_P _ss_ctx, ss_sess_P *_pss_sess);
sm_ret_T ss_sess_free(ss_sess_P _ss_sess);

sm_ret_T ssm_mail_new(ss_ta_P _ss_ta, bool _alloc_pa, ss_mail_P *_pmail);
sm_ret_T ssm_mail_free(ss_ta_P _ss_ta, ss_mail_P _mail);
sm_ret_T ssr_rcpts_new(ss_ta_P _ss_ta, ss_rcpts_P _rcpts, ss_rcpt_P *_prcpt);
sm_ret_T ssr_rcpt_free(ss_ta_P _ss_ta, ss_rcpt_P _rcpt);
/* sm_ret_T ssr_rcpts_free(ss_ta_P _ss_ta, ss_rcpts_P _rcpts); */
sm_ret_T ss_ta_clr(ss_ta_P _ss_ta);
sm_ret_T ss_ta_abort(ss_sess_P _ss_sess, ss_ta_P _ss_ta);
sm_ret_T ss_ta_init(ss_sess_P _ss_sess, ss_ta_P _ss_ta);

#endif /* SMTPSH_H */
